var flame64 = "data:image/png;base64,\
iVBORw0KGgoAAAANSUhEUgAAABkAAAAZCAYAAADE6YVjAAAAAXNSR0IArs4c6QAAAAZiS0dEAAAA\
AAAA+UO7fwAAAAlwSFlzAAALEwAACxMBAJqcGAAAAAd0SU1FB9wDDA44BL4y5nQAAAL5SURBVEjH\
tZZBaxVXFMd/586dN+/FhJjRRCUhpQUhhVpx4cqNm27K66oLF1Ip9Gv4fbro0kg/QcGiKxWki4qG\
LoQ2DzUm5r25M8dFzk2PQ9RAmwOXe7l37v8/55z/OTOCszSugy0DIEDRW4t7XIHW5q63Jm5Ouvyg\
9MAxsAwebXhwMTBPlmxksjYfxs1JF3nfMkEEBgYY3F4m0J4HYucJmBlWmx2IzotMUNkF70lpc+GI\
WgNtnCdiY+qJ4hEEfj2wuXJE4kLUGODUPJjZWeWJogvHwL3t0MacjVHPw85IpsBbYM+G9PI2AzS6\
uGeAygjmgQWbR7ZXOoAG2Hf7wQmhczmS2EtqTvicESzKtz9dZuPql3rv7hZrF1doZsqrv99w79ct\
9l7vALuGgRNCVloJHKrLJ7oyknnKalFu3S6Ym78h176bUVYVqkgIotP9fV5vP6Yc/Nb9sHHfwBuX\
m5RLwSumcIkeASO+uHSB0fyPIiEwGA4Pon0QdqmGQ5ZXrwCrSHiCdlML31vLVWPeSHCuhh7RkDMX\
arRb48NWaGrOyjc3Nyw3WZGFwy2CU0ToFWPJ2sUVQlF8hASJZan1+dNI8OosnBAk+PbiiumAPDUd\
nzBtU8vTR9t2J7x333Cjkx29dqHU5+bkIAcT4C+bAWpgDahJs4bpXlZT5zAOLboN39wSMAvrG69U\
VUXkd+Bhj+RrVb1GrEYsnYtolxXVullzMbZZz7aemTpe8PlXf4pIZwQPgB3gjRXocxG5riFEntz/\
GVh17SUTAbSSxnVuH7mdLJiEnxV3tj8z0BVrG7iuOwW+B34RkT/SuF4C1k26OybnFtjPJAPzJlf7\
LvAP0MbNiaoqrpZ860BENI3rLJxTwLIR5PBNo3Mt95od4KX7HoiIKKCqmg6la0XpCLCXC/ayub+1\
ksZ1dD0rutbdHfEFPI4FYNHlN8VewjP7cQGPss6ikaN02CDzNzk5VfwXS75e4hEH/5dlFYr/W+k4\
AYubk39/ddK4PhECgHch9yKyucKz8QAAAABJRU5ErkJggg==";

var candle64 = "data:image/png;base64,\
iVBORw0KGgoAAAANSUhEUgAAAG4AAACXCAYAAAD0xm4qAAAAAXNSR0IArs4c6QAAAAZiS0dEAP8A\
/wD/oL2nkwAAAAlwSFlzAAALEwAACxMBAJqcGAAAAAd0SU1FB9wDDA8GMaiGUx0AAAyOSURBVHja\
7Z3teeO4DoXPzpMOgB7oGjY93CJuibeHbA1WDwc17P1BUiIpUpb8PR7gmWQcx5ElvgRwANL2XwD+\
hdtvZ798CBycm4Nzc3AOzs3BuTk4B+fm4NwcnJuDc3BuDs7NwTk4Nwfn5uDcHJyDc3Nwbg7Owbk5\
ODcH5+bgHJybg3NzcA7OzcG5OTgH5+bg3Bycm4NzcG4Ozs3BOTg3B+fm4NwcnINzc3BuDs7BuTk4\
Nwfn5uAcnJuDc3NwDs7Nwbk5ODcH5+DcHNzVpn8QuL/wIR/REkKAQgEQNIOBIB3c2/taCAE6uxwB\
AoDl/2AA+EEkvz4iRCZgmUv0O0Ah8XeqUGaedHDvZAZAFn9b8h013cePgfYx4oTpuzX3cb5NTNP0\
UTnuMzyOBEWgIMyi52WPowBmXg68daykxRtWeFvkOjm496/gpAqXZp9ZE3zhk1yu8bQSotdxL+l6\
LMrw8hE4/6wKCCQGz6IU0PRYgQCqMDJJGzq4I8AEQFiGG+lfUoYCSIJinCHEB5dh0WBNnaZQ/B3C\
fKz6eWV+rjMJswmk5d5L4cMjFfuHhsrsHyF9qWqlBrNPUIoiO34Dg6wG0gD8YKq6IwShGvAtUsFs\
zyLkck8MwIQpi50OrVwv2otBfr0ClhSedkrATgAgcUgk5SYFEHJbpBh8SfeppqNIUpQC/PxvWj3n\
90lnrxWrjzW3w2YCAd+UWZ3OhELszBDElKBa6qyVIPkp4DTNaCl+nr1LSpiSQqQscKVAHZ0NhEJE\
oaeEOx0oTIafjuz/mSb89z8B4STDjKq0GKpDei6mxxhBLrnTAkBKnGSpD0oDJhK0CFIKqcTfDVzp\
Wd95PFTnlJThQItiWUq4Wh9Il2IaqlAVIJyi58ydZStuLzYxZqxQtcK4PLlxrIw0QMOiUJWGEHL/\
WufG9Sl58Nlinj0nV5weGFK/7g0sC41TkbN0VuYy64wVLC0ItQMpKQ6q5vi5qJm5QyKb6p8Xm2Ys\
JgCahmcthjQlQAUQRMEQuzOBcXJ9m4BimIw4J4D3Fjd3A5dFxgkKUUBFEkhbWDTpKqu6HfVADKNx\
pBaVWXrPwEQ7B5/jGRufsI36xIb1yzI5FUGjF04iUEtBweLa4Kqj82pwEZriO+UolbpfGK9p8Qht\
L147l1F4Dw2FGEmPpdaDORkwccPV9AJoq2rA2n3tUBEaJyRh53jNOgkIwwRCGoB8FbjvBC2o4NQF\
VusLdEMiN5sdmvQCyTSzDWU5jdRcts5CqbUUBXVYnMOkbHZkLkJrwqtCoSdACEwg1ASaVOhEQrCE\
UD4TnAL4O+WyAJnn6MqbSuk9X+TgVGXtHbRFfZJTahgH6ClLmKWyEu0fUnWBP4MwdoasFPZ23aC0\
4V3y0Wwen5MozhMTa001KB8PTud8lopnJDmdYvp8ttKowlE2kj1JjlADSAPwD4gQ1WWaCMp4Pqsu\
iWoswNJj4zmwKNt70MoSPp+ZHhsgFuetueBJKxeMEz4/9JzmMh8NTlJ4lJTTsgCR4ruNIp82qWSV\
jOqeo8r6PgMgU/S8eDxdOe0ybsRkRJiHv4HGjMa6bA7vHONqukGFcydodWyzOVodAffrGm/L3SdF\
LcFtFWKsPwhq8euiNO8Uy2msDQBz64JMACxWCqopEkQ7/0zgmQlawYuXJIKWmvG6pmVqGuTjaNuM\
gKSvY5Pkao/LEVEGTyiCFNWLPKQdBSI7pnCHMVn4dnwySFFLi+rSx8ptDeaBHAxS+Quy2IXUWXy4\
UdOXhxNYwrd/V8zX0SeTct7Ydjm1K3XZXoCLxAyMuUKbAylYVxha9GFos1BSWJ3/uhFb9xVdZK2U\
2/vZqGj2ModAYZj6D7kNnK6Ch9WjnVdeDB11Jxv8LpBb6QVLl7odDQDgJDKvsxkltq+2vKe8kxtZ\
jqw71Ne0a8xWcloPaNmvI57WH9X1Ektc15LYNdiTzLW4EJGLatxStjLWna9S0OpKqBhguqgA7cQ8\
bs2YgS/IdriolpEycFpz/cdLj8M5TjZ+WiYTl45/W3SzburmMJE3sG6uXiZZHdTKdZgGaa3fJDGg\
AYGswgFpddM7PzYtysZcaVAZaT7ZF6dSDUDGDo8Vy0KtZ94tx+lI361miqSBi+dpxtgZkNgxqOJ9\
MeNzjaOjMKO9E5LF07KLEY1/6Vym5G4JiRgui/yla1k8q+bdZr1WUW7FLVvfzYp9MXxCy0s2VJjN\
edeqjGYgzAibYmNYS5WGAmKPGNucJuuQpcC8PM7cm1i8O/cEJSlMS9kuzjUuHt6NjGPVS9sK/1oc\
J14HmbJA8u4cJS2dA+fQz8cX4GlTwNK9aiS2zihj8Yt/iCDamQBs1Kh2GaraoIm5bldJR9WqxIZB\
uUdFh+KnF50zEA4mcK12mCeS1Tpm/o+o2gDXbI3/2uNtl6KYFZV/rT6TiADxMxFqhMiyE8i03MZQ\
5xFtlbU2Sq9cUdClf8xCBFixnq55LU/acDGOWbryonVbn+UPaa9DtUhhzfxYQVtuH5EoF3d5hY6y\
1Kamy9pDun4TJbk1l5khf4cQ62czTKn9FNK2Oh3lfi1XF4rQSls2+hSzKIQADblTbaCx3227oH5n\
5zFba6NOCK2crQLGVY8oQ5zu5XF2QewO2xFcsvOyYKpF4czUrJ4zUWxhpQOFcgF2JbvHXtLv76dl\
mwTtn3NsiodW4RsxQYvBS5q3LdJtXaGuuqWsG4DnATDsKzqOe1y5XCNNGGw9sLMgUK8OpGlqRdwL\
AEQCDIafiSkKLv2EHAM1NbWB3haFooi3ZX/lPL4hLJ35tFQE5n6rzoqzOt3U7xSRIhrUoVO6OURW\
XdtzI0Z6ATn/3u4FDvPSTSmeWYRLXe0+kK2yQnubU8cRy/bEsix8VGbH1CxGdBGfq6ZFFi2jtrYB\
cdPIhAm2KEKWyj9t5Rssvk9DYCW0ZaLdtVdpG0sctixegJ22TbvMohzXSL0cIc0Fjk7QUu6J3Zo6\
P86idN6PWcjNlJx1lYwM5DnWXk3OrK6dNtItlfjYhnZ8O98uj2tXt3sipVRh2ghqGXjesDN/Teuv\
c7Cle5Z+LvZtQuJaXt46GJeKWLx8fIKlna+CcReuFhhcnScvTNFrvO1QHdfzOm4OrxblwgKw9Lw9\
5YdteOQoqVtKqNYOksUynXPZC0zNwjebtuIJbdXA6rHHN/7oXdaFDhfgHITAPac5fJ12U1rJgW7g\
nGOqGlKbTV11DGhdoncNp24pwGrDwwjYthLnsI2Ne4dKDGo5Kea6Xgivuqru9nnSvBczD8hgppju\
n8QsB1cFRusKFKJRp4MQeY1Zcy5Hfe/wy6y0M+iy8djQgNMdnZlHvEMQLwzeCNj1gDYX/VbP/bAc\
1xuArQ0u0rTGRm0x2/i7S8PCXTn3cliq81ZdAnN3CNyfie/xXgI3vbCx5229V2PXS0M6uH80PXR3\
D9WGU02rjXZ1yNyWWBxMrm15VKpGDlUpNzz/oeC2im7dyGfa3azGzeUSvaJQYMeDymNapy/PA22n\
7fCoVYnQwuWFkP1wcHvy1jov6k5g2/lz74Bb1xv21lyXu4mXtp1oN6awqeWeGCq3gpkc8M5L2UHv\
cnbcnPXXKsS93lLCYwf808HpgZrryGPH0BZZovOCLnfP9PWjyxz4GGhbrYtrX4L8VHDXwhvPXu70\
GC1u1fvzuOGRe4tkHj57boqVtwdX/o0Nbj/T7EooeiXQW15m/LR3XdAdJ2+DmukIyN7bWWxNFLvR\
k/SOk+StQ+XRi5UrQtC9BmcPQL25+H8RuD1q8RZ4t4bMR7/jIW88h5e9lBgHW0L6QEijY9qbQrvF\
fj3rAq5J2Gvc2vnadzy5MzC+2Nvv/n6Vdve/vfR+Gtu/lxvOiw0oHph49y8jHgzuGXlljzC59Vy2\
VrVHcOyJ13+3tz3c2/a6Lt/pweE+NoB80STlO4B7BLxnGF8A7B7gHl6AXxIHfCJAXnHuRwr2/Byj\
twJ7y1C514OOeOA9Lp43eNG1pcSlych3BLfXe97xba7tzpNEcevC7JPB/Y7wbhUZj/Sup4K7p4B5\
Zy97FqiXg9vyRrly0EdvUChPqC/bUKhPgvfSt6/fU8f9Dh+LwycCewtw71DH3SMs7lnaubd90Ee0\
PAfOK/PaW3ncMz2PVz73O35wy693m9mPHjA9eE7v+mk7b/nhtvfolugDPfQd7G1zHAcdiEcoP/3N\
oL2txz0i/33ax//9dp8Drn8YoI8B14P4p8D6GHB/sv3yIXBwbg7OzcE5ODcH5+bgHJybg3NzcG4O\
zsG5OTg3B+fg3Byc28Ps/+gZT5QjGIKYAAAAAElFTkSuQmCC";

GameEngine.Renderer.generateCanvas();
GameEngine.Renderer.setCanvasSize(150, 200);
GameEngine.Renderer.setBackgroundColor("black");
GameEngine.Renderer.setFramerate(15);

var fireParticle = new GameEngine.Renderer.Model(flame64);
var fireSource = new GameEngine.Renderer.Model(candle64);

fireSource.x = GameEngine.Renderer.canvas.width/2;
fireSource.y = GameEngine.Renderer.canvas.height-(151/2);

var fireTransparency = 0.99;
var fireBase = 3;
var fireSize = 0.92;
var instability = 0.003;
var maximumInstability = 0.03;
var flameHeight = 3;
var flameDensity = 20;

var randomValue = 0.5;

function gameFunction() {
	GameEngine.Renderer.clearScreen();
	
	fireSource.render();
	
	fireParticle.x = fireSource.x;
	fireParticle.y = fireSource.y-fireBase*2;
	
	fireParticle.scaleX = fireBase;
	fireParticle.scaleY = fireBase;
	
	fireParticle.transparency = 1;
	
	var randomTotal = 0;
	
	for(var i=0; i<flameDensity; i++) {
		fireParticle.scaleX *= fireSize;
		fireParticle.scaleY *= fireSize;
		
		fireParticle.render();
		
		fireParticle.transparency *= fireTransparency;
		
		randomValue += Math.random()*instability - instability/2;
		
		if(randomValue > maximumInstability)
			randomValue = maximumInstability;
		else if(randomValue < -maximumInstability)
			randomValue = -maximumInstability;
		
		randomTotal += randomValue;
		
		fireParticle.x += randomTotal;
		fireParticle.y -= flameHeight*fireParticle.scaleY;
	}
}

GameEngine.startGame(gameFunction);